HDOJ/HDU 1087 Super Jumping! Jumping! Jumping!(经典DP~)

网友投稿 531 2022-05-29

Problem Description

Nowadays, a kind of chess game called “Super Jumping! Jumping! Jumping!” is very popular in HDU. Maybe you are a good boy, and know little about this game, so I introduce it to you now.

The game can be played by two or more than two players. It consists of a chessboard(棋盘)and some chessmen(棋子), and all chessmen are marked by a positive integer or “start” or “end”. The player starts from start-point and must jumps into end-point finally. In the course of jumping, the player will visit the chessmen in the path, but everyone must jumps from one chessman to another absolutely bigger (you can assume start-point is a minimum and end-point is a maximum.). And all players cannot go backwards. One jumping can go from a chessman to next, also can go across many chessmen, and even you can straightly get to end-point from start-point. Of course you get zero point in this situation. A player is a winner if and only if he can get a bigger score according to his jumping solution. Note that your score comes from the sum of value on the chessmen in you jumping path.

Your task is to output the maximum value according to the given chessmen list.

Input

Input contains multiple test cases. Each test case is described in a line as follow:

N value_1 value_2 …value_N

It is guarantied that N is not more than 1000 and all value_i are in the range of 32-int.

A test case starting with 0 terminates the input and this test case is not to be processed.

Output

For each case, print the maximum according to rules, and one line one case.

Sample Input

3 1 3 2

4 1 2 3 4

4 3 3 2 1

HDOJ/HDU 1087 Super Jumping! Jumping! Jumping!(经典DP~)

0

Sample Output

4

10

3

就是找最大的递增子序列!!!

用动态规划做~

从前往后依次计算出当前递增子序列的值~dp[i]

最后找出最大的dp[i]就是答案~~

import java.util.Scanner; /** * @author 陈浩翔 * * 2016-5-26 */ public class Main{ public static void main(String[] args) { Scanner sc =new Scanner(System.in); while(sc.hasNext()){ int n=sc.nextInt(); if(n==0){ break; } int a[]=new int[n]; int dp[]=new int[n]; for(int i=0;imax){ max=dp[j]; } } dp[i]=a[i]+max; } int max=dp[0]; for(int i=1;imax){ max=dp[i]; } } System.out.println(max); } } }

1

2

3

4

5

6

7

8

9

10

11

12

13

14

15

16

17

18

19

20

21

22

23

24

25

26

27

28

29

30

31

32

33

34

35

36

37

38

39

40

41

42

版权声明:本文内容由网络用户投稿,版权归原作者所有,本站不拥有其著作权,亦不承担相应法律责任。如果您发现本站中有涉嫌抄袭或描述失实的内容,请联系我们jiasou666@gmail.com 处理,核实后本网站将在24小时内删除侵权内容。

上一篇:数据可视化方式6
下一篇:Unity 之 ExecuteAlways正在取代ExecuteInEditMode
相关文章